;;;                                        <einfache Tiefensuche.scm>
;;; Grundprogramm zur Tiefensuche
;;; ===== Tiefensuche ===============================================
; bentigt die beiden globalen Variablen Kantenliste und Zielknoten.
; Das macht das Programm zwar bersichtlicher, sollte aber durch
; bergaben ersetzt werden.
(define
  (Tiefensuche Alternativen)
  (cond
    [(null? Alternativen)
     #f]
    [(equal? (car Alternativen) Zielknoten)
     (Ausgabe (car Alternativen))
     #t]
    [(Tiefensuche (Nachfolger (car Alternativen)))
     (Ausgabe (car Alternativen))]
    [else
     (Tiefensuche (cdr Alternativen))]))

;;; ===== Nachfolger ================================================
; Bestimmt eine Liste der Nachfolgeknoten
(define
  (Nachfolger Knoten)
  (cadr (assoc Knoten Kantenliste)))
;;; ===== Ausgabe ===================================================
; Gibt den aktuellen Knoten des Weges aus.
(define
  (Ausgabe Knoten)
  (display Knoten)
  (display " <-- "))
;;; ===== Kantenliste ==================================================
; globale Variable in welcher die Kantenliste des Graphen gespeichert wird.
(define
  Kantenliste
  '((0 (3))
    (1 (2 4))
    (2 (1))
    (3 (0 4))
    (4 (1 3 5 7))
    (5 (4 8))
    (6 (9))
    (7 (4 8 10))
    (8 (5 7))
    (9 (6 10 12))
    (10 (7 9 11 13))
    (11 (10))
    (12 (9))
    (13 (10 14))
    (14 (13))))
;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;;  0          1    ---   2          
;;;  
;;;  |          |                     
;;;  
;;;  3    ---   4    ---   5          
;;;  
;;;             |          |          
;;;  
;;;  6          7    ---   8          
;;;  
;;;  |          |                     
;;;  
;;;  9    ---   10   ---   11         
;;;  
;;;  |          |                     
;;;
;;;  12         13   ---   14         

;;; ===== Zielknoten ================================================
(define Zielknoten 9)

;;; ~~~~~ warum funktioniert es nicht ? ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;(display "Der folgende Aufruf geht schief!")(Tiefensuche (Nachfolger 1))





;;;==================================================================
;;; Der Graph muss gerichtet sein, sonst entstehen primitive Zyklen.
(define
  Kantenliste
  '( (1 (2 4))
     (2 (3))
     (3 (6))
     (4 (5 7))
     (5 (8))
     (6 (9))
     (7 ())
     (8 ())
     (9 ())))

;;;==================================================================
;;; Labyrinth dazu :
;;;                
;;;                1 - 2 - 3
;;;                I  I
;;;                4 - 5   6
;;;                I  I  I
;;;                7  8   9
;;;                
(display "Nun geht es:  ")(Tiefensuche (Nachfolger 1))(display 1)
